local oUF_HealComm = {}
local healcomm = LibStub("LibHealComm-3.0")
local playerName = UnitName("player")
local playerIsCasting = false
local playerHeals = 0
local playerTarget = ""

--update a specific bar
Lunar_Update_HealCommBar = function(frame) -- Global
    local unit = frame.LookupName
    if frame.ignoreHealComm or not UnitExists(unit) then return end
    local maxHP = UnitExists(unit) and UnitHealthMax(unit) or 0 
    local incHeals = select(2, healcomm:UnitIncomingHealGet(unit, GetTime())) or 0
    --add player's own heals if casting on this unit
    if playerIsCasting then
        for i = 1, select("#", playerTarget) do
            local target = select(i, playerTarget)
            if target == unit then
                incHeals = incHeals + playerHeals
            end
        end
    end    
    frame.Lunar_HealCommBar:SetValue(incHeals>0 and (incHeals / maxHP) or 0)
end
local Lunar_Update_HealCommBar = Lunar_Update_HealCommBar

--used by library callbacks, arguments should be list of unit names to update
local Lunar_Update_All_HealCommBars = function(...)
    local unit
	for i = 1, select("#", ...) do
		unit = select(i, ...)
        --search current oUF frames for this unit
        for _, frame in ipairs(Lunar_OpenUnitFrames) do
            if unit == frame.LookupName then
                Lunar_Update_HealCommBar(frame)
            end
        end
	end
end

--set up LibHealComm callbacks
function oUF_HealComm:HealComm_DirectHealStart(event, healerName, healSize, endTime, ...)
	if healerName == playerName then
		playerIsCasting = true
		playerTarget = ... 
		playerHeals = healSize
	end
    Lunar_Update_All_HealCommBars(...)
end

function oUF_HealComm:HealComm_DirectHealUpdate(event, healerName, healSize, endTime, ...)
    Lunar_Update_All_HealCommBars(...)
end

function oUF_HealComm:HealComm_DirectHealStop(event, healerName, healSize, succeeded, ...)
    if healerName == playerName then
        playerIsCasting = false
    end
    Lunar_Update_All_HealCommBars(...)
end

function oUF_HealComm:HealComm_HealModifierUpdate(event, unit, targetName, healModifier)
    Lunar_Update_All_HealCommBars(unit)
end

healcomm.RegisterCallback(oUF_HealComm, "HealComm_DirectHealStart")
healcomm.RegisterCallback(oUF_HealComm, "HealComm_DirectHealUpdate")
healcomm.RegisterCallback(oUF_HealComm, "HealComm_DirectHealStop")
healcomm.RegisterCallback(oUF_HealComm, "HealComm_HealModifierUpdate")
