local function debug (message)
    DEFAULT_CHAT_FRAME:AddMessage(message)
end

---------------------------------------------------- Declare locals for later use
local MaxBuffs = 40
local DefaultSpacer = 35

---------------------------------------------------- Fonts and textures 
local texturebar = 'Interface\\Addons\\oUF_Lunar\\media\\Smoothv2.tga' 
local texturexp = 'Interface\\Addons\\oUF_Lunar\\media\\xp'
local texturexpback = 'Interface\\AddOns\\oUF_Lunar\\Media\\xpbackbar.tga'
local BrightTexture = 'Interface\\Addons\\oUF_Lunar\\media\\Melli.tga'
local bubbleTex = 'Interface\\Addons\\oUF_Lunar\\media\\bubbleTex.tga'
local fontpath = "Fonts\\FRIZQT__.TTF"

---------------------------------------------------- font function
local function MyFont(size)
    return fontpath, size;
end

---------------------------------------------------- Power colors
oUF.colors.power[0] = {0.1,0,1}         --Mana
oUF.colors.power[1] = {0.88,0.16,0.29}  --Rage
oUF.colors.power[2] = {1.0,0.85,0.09}   --Focus
oUF.colors.power[3] = {1.0,0.85,0.09}   --Energy
oUF.colors.power[4] = {0.4,0.4,0.4}     --Happiness
oUF.colors.power[5] = {0.7,0.7,0.7}     --Runes
oUF.colors.power[6] = {0.7,0.7,0.7}     --Runic Power

oUF.colors.tapped = {.55,.57,.61}
oUF.colors.disconnected = {0.6,0.6,0.6}
oUF.colors.agro = {1,0,0}

local conv = {
    ['playerpet'] = 'pet',
    ['playertarget'] = 'target',
}

local narrowBorder = {
    bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", 
    edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", tile = true, tileSize = 16, edgeSize = 16, 
    insets = { left = 3, right = 3, top = 3, bottom = 3 } 
}
local MainBorder = {
    bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
    edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", tile = true, tileSize = 16, edgeSize = 16, 
    insets = { left = 3, right = 3, top = 3, bottom = 3 } 
}
--------------------------------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------- Set Styles-------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------
function oUF_Lunar_Static_Style(self, unit)
    local frameName = self:GetName()
    local frameType = self.frameType
    -- clean this up
    
    self:RegisterForClicks('AnyUp')
    self:SetAttribute('*type2', 'menu')
    
	self:SetScript('OnEnter', UnitFrame_OnEnter)
	self:SetScript('OnLeave', UnitFrame_OnLeave)
    
	local _, class = UnitClass('player')
        
    -- Handle potential enemy frames
    local NonGroupFrame
    if (strmatch(frameType,'Target') or unit=='focus') then
        NonGroupFrame = true
        self.NonGroupFrame = true
    else
        NonGroupFrame = false
        self.NonGroupFrame = false
    end

    -- Handle all party and raid
    local group
    if strmatch(frameName, '%d') or strmatch(frameName, 'unit') then
        group = true
        self.group = true
    end
    
    ---------------------------------------------------- Background / border
    do
        local Spacer = 4
        local Background = CreateFrame('frame', nil, self)
        Background:SetFrameStrata("BACKGROUND")
        Background:SetPoint('TOPLEFT', -Spacer, Spacer)
        Background:SetPoint('BOTTOMRIGHT', Spacer, -Spacer)
        Background:SetBackdrop(MainBorder);
        Background:SetBackdropColor(0,0,0,0.5)
        Background:SetBackdropBorderColor(0,0,0,0.35)
        self.Background = Background
    end
    ---------------------------------------------------- Portrait, class, or type icons
    local IconFrame = CreateFrame("Frame", "IconFrame", self)
    --Set Point happens during loading
    IconFrame:SetPoint('TOP', self, 'TOP')
    IconFrame:SetPoint('BOTTOM', self, 'BOTTOM')
    
    local Portrait = CreateFrame("PlayerModel", nil, self)
    Portrait:SetAllPoints(IconFrame)
    
    local Portrait_2d = IconFrame:CreateTexture(nil, "BORDER")
    Portrait_2d:SetAllPoints(IconFrame)
    
    self.IconFrame = IconFrame
    self.IconFrame.Portrait_2d = Portrait_2d
    self.IconFrame.Portrait = Portrait    

    ---------------------------------------------------- Threat Icon
	self.Pre_Threat = self.IconFrame:CreateTexture(nil, 'BACKGROUND')
	self.Pre_Threat:SetTexture(BrightTexture)
    self.Pre_Threat:SetAllPoints(IconFrame)
    self.Pre_Threat:Hide()
    self.ThreatDisabled = true
    
	---------------------------------------------------- Castbar 
    -- Note the real cast bar is not assigned till load.
    do
        local Castbar = Create_UberStatusBar(nil, self)
        Castbar.delay = 0
        Castbar.duration = 0
        Castbar:SetStatusBarTexture(BrightTexture)
        Castbar:SetStatusBarColor(1,1,1)
        Castbar:SetFrameStrata("TOOLTIP")
        Castbar:SetMinMaxValues(1, 100)
        Castbar.Spark = Castbar:CreateTexture()
        Castbar.Spark:SetBlendMode('ADD')
        Castbar.Spark:SetVertexColor(1, 1, 1,1)
        
        Castbar.Text = Castbar:CreateFontString(nil, 'OVERLAY')
        Castbar.Text:SetFont(fontpath, 10, "OUTLINE")
        Castbar.Text:SetShadowOffset(1, -1)
        Castbar.Text:SetPoint('TOPLEFT', Castbar, 'TOPLEFT', 2, 0)
        Castbar.Text:SetPoint('TOPRIGHT', Castbar, 'TOPRIGHT', -2, 0)
        Castbar.Text:SetJustifyH('CENTER')

    -- Handle Cast Bar Gradient
        local function Gradient_Update(Castbar, elapsed)
            if not Castbar.ClassColor then
                local _,max = Castbar:GetMinMaxValues()
                local min = Castbar:GetValue()
                Castbar:SetStatusBarColor(Castbar.ColorAlphaGradient(min/max, unpack(Castbar.smoothGradient)))
            end
            if Castbar.OnUpdate then
                Castbar.OnUpdate(Castbar, elapsed)
            end
        end       

        Castbar.Old_SetScript = Castbar.SetScript
        Castbar.SetScript = function(Castbar, event, func)
            if event == 'OnUpdate' then
                Castbar.OnUpdate = func
                Castbar:Old_SetScript(event, Gradient_Update)
            else
                Castbar:Old_SetScript(event, func)
            end
        end
        self.CastbarDisabled = true
        self.Pre_Castbar = Castbar
        self.Pre_Cast = Castbar
    end
	---------------------------------------------------- Powerbar 
	self.Pre_Power = Create_UberStatusBar(nil, self)
    self.Pre_Power:Hide()
    self.PowerBarDisabled = true
    self.Pre_Power.Smooth = true
    self.Pre_Power:SetPoint('BOTTOMLEFT', self.Pre_Castbar, 'TOPLEFT')
    self.Pre_Power:SetPoint('BOTTOMRIGHT', self.Pre_Castbar, 'TOPRIGHT')
	
    if NonGroupFrame or frameType == 'oUF_Lunar_Player' then
        self.Pre_Power.Height = 10
    else
        self.Pre_Power.Height = 5
    end
    self.Pre_Power:SetHeight(self.Pre_Power.Height)
    
	self.Pre_Power:SetStatusBarTexture(BrightTexture) 
    self.Pre_Power.frequentUpdates = (unit=='player')
    self.PowerColor = {}
    self.PowerType = 0
   
	----------------------------------------------------Power Text    
    self.Pre_Power.value = self.Pre_Power:CreateFontString(nil, 'OVERLAY')
    self.Pre_Power.value:SetFont(fontpath, 10)
    self.Pre_Power.value:SetShadowOffset(1, -1)
    
    self.Pre_Power.total = self.Pre_Power:CreateFontString(nil, 'ARTWORK')
    self.Pre_Power.total:SetFont(fontpath, 9)
    self.Pre_Power.total:SetShadowOffset(1, -1)
	 
	---------------------------------------------------- Healthbar 
	self.Health = Create_UberStatusBar(nil, self) 
    self.Health.Smooth = true
	self.Health:SetStatusBarTexture(BrightTexture) 
    self.Health:SetPoint('BOTTOMLEFT', self.Pre_Power, 'TOPLEFT') 
    self.Health:SetPoint('BOTTOMRIGHT', self.Pre_Power, 'TOPRIGHT')
    self.Health:SetPoint('TOP', self, 'TOP') 
    self.Health.frequentUpdates = true
    self.Pre_Health = self.Health
    
	---------------------------------------------------- Health Text
	self.Health.value = self.Health:CreateFontString(nil, 'OVERLAY')
    self.Health.value:SetFont(fontpath, 14)
    self.Health.value:SetShadowOffset(1, -1)
    self.Health.value:SetTextColor(1,1,1)

    self.Health.total = self.Health:CreateFontString(nil, 'ARTWORK')
    self.Health.total:SetFont(fontpath, 9)
    self.Health.total:SetShadowOffset(1, -1)
    self.Health.total:SetTextColor(1,1,1)
    
    if unit ~= 'target' then
        self.Health.total:Hide()
    end
    
	---------------------------------------------------- Highlighting
	self.Highlight = self:CreateTexture(nil, 'HIGHLIGHT') -- set the highlight to th self frame so it doesn't interfere with hp clicking --
	self.Highlight:SetAllPoints(self) -- so the highlight is over the Health frame 
	self.Highlight:SetTexture(0.7,0.7,0.7,0.3) 
	self.Highlight:SetBlendMode('ADD')
	----------------------------------------------------Level & Name & Class placement
    self.Name = self.Health:CreateFontString(nil, 'ARTWORK')
    if NonGroupFrame then
        self.Name:SetFont(fontpath, 12, "OUTLINE")
        self.Name:SetShadowOffset(2, -2)
        self.Name:SetPoint('BOTTOMLEFT',self, 'TOPLEFT', 0, 2) 
        self.Name:SetPoint('BOTTOMRIGHT',self, 'TOPRIGHT', 0, 2) 
    else
        self.Name:SetFont(fontpath, 10)
        self.Name:SetShadowOffset(1, -1)
        self.Name:SetJustifyV('CENTER')
	end
	---------------------------------------------------- Combo Points
	if NonGroupFrame then
        self.CPoints = {}
        self.CPoints.unit = 'player'
        for i = 1, 5 do
            self.CPoints[i] = self:CreateTexture(nil, 'OVERLAY')
            self.CPoints[i]:SetHeight(24)
            self.CPoints[i]:SetWidth(24)            
            self.CPoints[i]:SetTexture(bubbleTex)
            if (i == 1) then
                self.CPoints[i]:SetPoint('BOTTOMLEFT', self, 'TOPLEFT', 0, 16)
                self.CPoints[i]:SetVertexColor(1, 0.31, 0.31)
            else
                self.CPoints[i]:SetPoint('LEFT', self.CPoints[i-1], 'RIGHT', 1)
            end
        end
        self.CPoints[2]:SetVertexColor(1, 0.31, 0.31)
        self.CPoints[3]:SetVertexColor(1, 1, 0.35)
        self.CPoints[4]:SetVertexColor(1, 1, 0.35)
        self.CPoints[5]:SetVertexColor(0.33, 1, 0.33)
	end
		 
	---------------------------------------------------- Leader Icon 
	if(not unit or unit == 'player') then -- party or player gets a leader icon 
		self.Leader = self.Health:CreateTexture(nil, 'OVERLAY')
		self.Leader:SetHeight(10)
		self.Leader:SetWidth(10)
		self.Leader:SetPoint('TOPLEFT', self, -9, 2)
		self.Leader:SetTexture('Interface\\GroupFrame\\UI-Group-LeaderIcon')	 
        self.Leader:Hide()
	end 
    ---------------------------------------------------- AFK icon
     local afkIcon = IconFrame:CreateTexture(nil, "OVERLAY")
     afkIcon:SetPoint("CENTER")
     afkIcon:SetWidth(20)
     afkIcon:SetHeight(20)
     afkIcon:Hide()
     self.AFKIcon = afkIcon
     
	---------------------------------------------------- Raid Target Icon 
	self.RaidIcon = IconFrame:CreateTexture(nil, 'OVERLAY')
	self.RaidIcon:SetHeight(24)
	self.RaidIcon:SetWidth(24)
	self.RaidIcon:SetTexture('Interface\\TargetingFrame\\UI-RaidTargetingIcons')
    self.RaidIcon:Hide()
	---------------------------------------------------- Auras
    local BuffContainer = CreateFrame('CheckButton', nil, self)
    BuffContainer:SetPoint('TOPRIGHT', self, 'BOTTOMRIGHT', 6, 0)
    BuffContainer:SetPoint('TOPLEFT', self, 'BOTTOMLEFT', -6, 0)
    BuffContainer:SetPoint('BOTTOM', self, 'BOTTOM', 0, -35)
    do
        local Background = CreateFrame('frame', nil, BuffContainer)
        Background:SetPoint('TOPLEFT', BuffContainer, 'TOPLEFT', 0, 6)
        Background:SetPoint('BOTTOMRIGHT', BuffContainer, 'BOTTOMRIGHT', 0, -6)
        Background:SetBackdrop(narrowBorder);
        Background:SetBackdropColor(0,0,0,0.6)
        Background:SetBackdropBorderColor(0.5,0.5,0.5,0.8)
        Background:Hide()
        BuffContainer.Background = Background
    end
    self.BuffContainer = BuffContainer
    
    
    self.Auras = CreateFrame('StatusBar', nil, BuffContainer)
    self.Auras.spacing = 1
    self.Auras.gap = true 
    self.Auras.numBuffs = MaxBuffs
    self.Auras.numDebuffs = MaxBuffs
    self.Auras.isAura = true
    self.Auras.spacing = 2
    self.Auras.showDebuffType = true
    self.Auras.disableCooldown = true
    self.Auras.Position_Info = {}
    self.Auras['growth-y'] = 'DOWN'    
    self.Auras.Vis = 0
	---------------------------------------------------- Buffs & Debuffs
    self.Low_Buffs = CreateFrame('Frame', nil, self)
    self.Low_Buffs:SetHeight(16)
    self.Low_Buffs:SetPoint('TOPLEFT', self, 'BOTTOMLEFT',0,-1) 
    self.Low_Buffs:SetPoint('TOPRIGHT', self, 'BOTTOMRIGHT',0,-1)
    self.Low_Buffs['growth-x'] = 'RIGHT'
    self.Low_Buffs['growth-y'] = 'DOWN'
    self.Low_Buffs.initialAnchor = 'TOPLEFT'
    self.Low_Buffs.spacing = 1.0
    self.Low_Buffs.size = 16
    self.Low_Buffs.num = MaxBuffs
    self.Low_Buffs.onlyShowPlayer = false
    self.Low_Buffs.Position_Info = {}

    self.Low_Debuffs = CreateFrame('Frame', nil, self)
    self.Low_Debuffs:SetHeight(16)
    self.Low_Debuffs:SetPoint('BOTTOMLEFT', self, 'BOTTOMLEFT', 0, -34) 
    self.Low_Debuffs:SetPoint('BOTTOMRIGHT', self, 'BOTTOMRIGHT', 0, -34)
    self.Low_Debuffs['growth-x'] = 'LEFT'
    self.Low_Debuffs.initialAnchor = 'BOTTOMRIGHT'
    self.Low_Debuffs.spacing = 1.0
    self.Low_Debuffs.size = 16
    self.Low_Debuffs.num = 11
    self.Low_Debuffs.Position_Info = {}

    ---------------------------------------------------- oUF_WeaponEnchant
    if (IsAddOnLoaded('oUF_WeaponEnchant')) then
        self.Enchant = CreateFrame('Frame', nil, self)
        self.Enchant:SetHeight(16)
        self.Enchant:SetWidth(16 * 2)
        self.Enchant:SetPoint('BOTTOMLEFT', self, 'BOTTOMLEFT', 0, 0)
        self.Enchant.size = 16
        self.Enchant.spacing = 1
        self.Enchant.initialAnchor = 'TOPLEFT'
        self.Enchant['growth-x'] = 'RIGHT'
    end
    
    ---------------------------------------------------- Pet Happiness
    if unit == 'pet' then
        self.Happiness = self.Health:CreateTexture(nil, "OVERLAY")
        self.Happiness:SetPoint("CENTER", self, 'CENTER')
        self.Happiness:SetHeight(40)
        self.Happiness:SetWidth(40)
        self.Happiness:Hide()
    end
        
	---------------------------------------------------- oUF_CombatFeedback 
    self.CombatFeedbackText = IconFrame:CreateFontString(nil, 'OVERLAY')
    self.CombatFeedbackText:SetFont(fontpath, 12, "OUTLINE")
    self.CombatFeedbackText:SetShadowOffset(1, -1)
    self.CombatFeedbackText.maxAlpha = 1
    self.CombatFeedbackText:SetPoint('CENTER')
    if NonGroupFrame then
        self.CombatFeedbackText.ignoreDamage = true -- ignore damage hits, blocks, misses, parries etc.
    else
        self.CombatFeedbackText.ignoreHeal = true -- ignore heals 
    end
	self.CombatFeedbackText.ignoreOther = true  -- ignore everything else
    
	---------------------------------------------------- oUF_DebuffHighlight 
	self.DebuffHighlight = self:CreateTexture(nil, 'OVERLAY')
	self.DebuffHighlight:SetAllPoints(self)
	self.DebuffHighlight:SetTexture(BrightTexture)
	self.DebuffHighlight:SetBlendMode('ADD')
	self.DebuffHighlight:SetVertexColor(0,0,0,0) -- set alpha to 0 to hide the textur
	self.DebuffHighlightFilter = true
	self.DebuffHighlightAlpha = 0.6
    
    ---------------------------------------------------- HealComm
    do
        local hcb = Create_UberStatusBar(nil, self.Health)
        hcb:SetAllPoints(self.Health)
        hcb:SetStatusBarColor(1,1,1,0.7)
        hcb:SetStatusBar_BackColor(0,0,0,0)
        hcb.MainTexture:SetBlendMode('ADD')
        hcb:SetFrameLevel(21)
        self.Lunar_HealCommBar = hcb
        self.ignoreHealComm = true
    end

    ---------------------------------------------------- Range Alpha
    self.inRangeAlpha = 1
	---------------------------------------------------- ReadyCheck
	if group then
		self.ReadyCheck = IconFrame:CreateTexture(nil, 'OVERLAY')
		self.ReadyCheck:SetPoint('CENTER', self.Health, 'CENTER', 0, -6)
		self.ReadyCheck:SetHeight(34)
		self.ReadyCheck:SetWidth(34)
	end
    
    if unit=='target' or unit=='player' then
        ---------------------------------------------------- PvP Icon
        self.PvP = self:CreateTexture(nil, 'OVERLAY') 
        self.PvP:SetTexCoord(0, 0.6, 0, 0.6)
        self.PvP:SetHeight(14)
        self.PvP:SetWidth(14)
    end
    
    if(unit == 'player') then 
        ---------------------------------------------------- oUF_Autoshot 	
        if(IsAddOnLoaded('oUF_AutoShot') and class == 'HUNTER') then
            self.AutoShot = CreateFrame('StatusBar', nil, self)
            self.AutoShot:SetPoint('TOP', self, 'BOTTOM', 0, -20)
            self.AutoShot:SetStatusBarTexture(BrightTexture)
            self.AutoShot:SetStatusBarColor(.19,.19,.19,1)
            self.AutoShot:SetHeight(6)
            self.AutoShot:SetWidth(260)
            self.AutoShot:SetBackdrop({bgFile = 'Interface\\Tooltips\\UI-Tooltip-Background', insets = {top = -1, left = -1, bottom = -1, right = -1}})
            self.AutoShot:SetBackdropColor(.15,.15,.15)

            self.AutoShot.Time = self.AutoShot:CreateFontString(nil, 'OVERLAY')
            self.AutoShot.Time:SetFont(MyFont(12))
            self.AutoShot.Time:SetPoint('CENTER', self.AutoShot)

            self.AutoShot.MainTexture = self.AutoShot:CreateTexture(nil, 'BORDER')
            self.AutoShot.MainTexture:SetAllPoints(self.AutoShot)
            self.AutoShot.MainTexture:SetTexture(BrightTexture)
            self.AutoShot.MainTexture:SetVertexColor(.15,.15,.15)			
        end
        ---------------------------------------------------- oUF Experience
		if (IsAddOnLoaded('oUF_Experience') and UnitLevel('player') ~= 80) then
--~             local function ExpOverrideText(self, event, unit, bar, min, max)
--~                 self.Experience.Text:SetFormattedText('Exp: '..tonumber(min)..' / '..tonumber(max)..' (%.1f%%)', min/max*100)
--~             end            
			self.Experience = CreateFrame('StatusBar', nil, self)
			self.Experience:SetPoint('BOTTOMLEFT', self, 'TOPLEFT', 0, 5)
			self.Experience:SetPoint('TOPRIGHT', self, 'TOPRIGHT', 0, 8)
			self.Experience:SetStatusBarTexture(BrightTexture)
			self.Experience:SetStatusBarColor(1,1,1,0.7)
            self.Experience.Text = self.Experience:CreateFontString(nil, 'OVERLAY')
            self.Experience.Text:SetFont(fontpath, 12, "OUTLINE")
            self.Experience.Tooltip = true
            
			self.Experience.bg = self.Experience:CreateTexture(nil, 'BORDER')
			self.Experience.bg:SetAllPoints(self.Experience)
			self.Experience.bg:SetTexture(BrightTexture)
			self.Experience.bg:SetVertexColor(0.2,0.2,0.2,0.8)
			self.Experience.Rested = CreateFrame('StatusBar', nil, self)
--~ 			self.Experience.PostUpdate = ExpOverrideText
		end
            
        ---------------------------------------------------- Druid Mana	
        if(class == 'DRUID') then
            CreateFrame('Frame'):SetScript('OnUpdate', function() oUF_Lunar.UpdateDruidMana(self.DruidMana) end)
            self.DruidMana = self.Pre_Power:CreateFontString(nil, 'OVERLAY')
            self.DruidMana:SetFont(fontpath, 12, "OUTLINE")
            self.DruidMana:SetShadowOffset(2, -2)
            self.DruidMana:SetTextColor(0.27,0.52,0.83)
            self.DruidMana:SetPoint('CENTER',0,2)
        end
		
		---------------------------------------------------- Deathknight Runepower
		if(class == 'DEATHKNIGHT') then
			RuneFrame:SetParent(self)
			RuneFrame:ClearAllPoints()
			RuneFrame:SetScale(0.8)
			RuneFrame:SetFrameLevel(2)
			RuneFrame:SetPoint('CENTER', self, 'TOP', 0, 8)
            RuneFrame:Show()
		end
        
        ---------------------------------------------------- TotemBar
        if IsAddOnLoaded("oUF_TotemBar") and class == "SHAMAN" then 
            local Bar
            self.TotemBar = {} 
            for i = 1, 4 do 
                Bar = CreateFrame("StatusBar", nil, self)
                Bar:SetHeight(8) 
                if (i == 1) then 
                    Bar:SetPoint("BOTTOMLEFT", self.Health, "TOPLEFT", 0, 2) 
                else
                    Bar:SetPoint("TOPLEFT", self.TotemBar[i-1], "TOPRIGHT", 1, 0) 
                end 
                Bar:SetStatusBarTexture(BrightTexture)
                Bar:SetMinMaxValues(0, 1) 
                Bar.destroy = true 

                Bar.bg = Bar:CreateTexture(nil, "BORDER") 
                Bar.bg:SetAllPoints(Bar) 
                Bar.bg:SetTexture(0,0,0,1) 
                Bar.bg.multiplier = 0.25  
                self.TotemBar[i] = Bar
            end 
        end  
        ---------------------------------------------------- Rest Icon
		if UnitLevel('player') ~= 80 then
			self.Resting = self.Health:CreateTexture(nil, 'OVERLAY')
			self.Resting:SetHeight(24)
			self.Resting:SetWidth(24)
			self.Resting:SetPoint('BOTTOM', IconFrame,'TOP',0,3)
			self.Resting:SetTexture('Interface\\CharacterFrame\\UI-StateIcon')
			self.Resting:SetTexCoord(0,0.5,0,0.45)
		end
        ---------------------------------------------------- Combat Icon
		self.Combat = self.Health:CreateTexture(nil, 'OVERLAY')
		self.Combat:SetHeight(16)
		self.Combat:SetWidth(16)
		self.Combat:SetPoint('BOTTOM', self.PvP,'TOP')
		self.Combat:SetTexture('Interface\\CharacterFrame\\UI-StateIcon')
		self.Combat:SetTexCoord(0.58, 0.90, 0.08, 0.41)
    end 
    ---------------------------------------------------- Disable default oUF vehicle swap
    self.disallowVehicleSwap = true
	---------------------------------------------------- Frame Sizes
    self:SetAttribute('initial-height', 32)
	return self 
end 