local function debug (message)
    DEFAULT_CHAT_FRAME:AddMessage(message)
end
function oUF_Lunar_MakeWelcomeScreen(OptionsMenu, fontpath, narrowBorder)
    local Photo = 'Interface\\Addons\\oUF_Lunar_Config\\media\\Dawn-Welcome512.tga' 
    
    local WelcomeScreen = CreateFrame("frame", "WelcomeScreen", PhotoFrame)
    WelcomeScreen:SetHeight(200)
    WelcomeScreen:SetWidth(350)
    WelcomeScreen:SetPoint('CENTER',0,60)
    WelcomeScreen:EnableMouse(true)

    WelcomeScreen:SetBackdrop(narrowBorder)
    WelcomeScreen:SetBackdropColor(0,0,0,0)
    
    -- Background
    local Background_Photo = WelcomeScreen:CreateTexture(nil, 'BACKGROUND')
    Background_Photo:SetPoint('TOPLEFT', WelcomeScreen, 'TOPLEFT', 3, -3)
    Background_Photo:SetPoint('BOTTOMRIGHT', WelcomeScreen, 'BOTTOMRIGHT', -3, 3)
    Background_Photo:SetTexture(Photo)
    Background_Photo:SetTexCoord(0, 1, 0.18, 0.82)

    local Text = WelcomeScreen:CreateFontString(nil, 'OVERLAY')
    Text:SetFont(fontpath, 20, "OUTLINE")
    Text:SetTextColor(1,1,1)
    Text:SetShadowOffset(2, -2)
    Text:SetPoint('TOP', WelcomeScreen, "TOP", 0, -20) 
    Text:SetText("Welcome To Lunar Unit Frames")

    -- Fade_Animation
    local Fade_Animation = (WelcomeScreen:CreateAnimationGroup("Fade")):CreateAnimation("ALPHA", "Fade")
    Fade_Animation:SetChange(-1) 
    Fade_Animation:SetDuration(1)
    Fade_Animation:SetScript("OnFinished", function()
        WelcomeScreen:Hide()
        Background_Photo:SetTexture(0,0,0,0)
    end)

    -- Button to customize
    local Custom, Default;
    Custom = CreateFrame("Button", "ok", WelcomeScreen, "OptionsButtonTemplate")
    Custom:SetPoint("BOTTOMRIGHT", WelcomeScreen, "BOTTOM", -10, 20);
    Custom:SetWidth(130)
    Custom:SetText("Custom Setup")
    Custom:SetScript("OnClick", function() 
        Custom:Hide()
        Default:Hide()
        Fade_Animation:Play()
        InterfaceOptionsFrame_OpenToCategory(OptionsMenu.SubMenu_1)
        InterfaceOptionsFrame_OpenToCategory(OptionsMenu)
    end);
       
    -- Button for defaults
    Default = CreateFrame("Button", "ok", WelcomeScreen, "OptionsButtonTemplate")
    Default:SetPoint("BOTTOMLEFT", WelcomeScreen, "BOTTOM", 10, 20);
    Default:SetWidth(130)
    Default:SetText("Default Setup")
    Default:SetScript("OnClick", function()
        Custom:Hide()
        Default:Hide()
        Fade_Animation:Play()
    end)
end